//var slider = document.getElementById("myRange");
/*var output = document.getElementById("demo");

output.innerHTML = slider.value; // Display the default slider value
*/
var oe = document.getElementById("output_error");
oe.innerHTML = "Everything is OK";
oe.style.backgroundColor = "green";

//Variables//////////////////////////////////////////////////////////
var occuracy = 0.1;

var ib_max = 9;
var ib_min = 1;
var power_factor = 0.8; //COSfi

var pturbo_max = 3;
var pturbo_min = 1;


var nominal_current = 3; //statorovy proud

var calculated_curve_x = [-6.2, -6, -3.3, -2];
var calculated_curve_y = [0, 2.1, 2.6, 3];


Pmin.oninput = function() {
    pturbo_min = parseFloat(this.value);
}
Pmax.oninput = function() {
    pturbo_max = parseFloat(this.value); //this.value;
  //chart_update();
}
COSfi.oninput = function() {
    power_factor = parseFloat(this.value); //this.value;
    //chart_update();
}
Current.oninput = function() {
    nominal_current = parseFloat(this.value); //this.value;
    //chart_update();
}
IB_max.oninput = function() {
    ib_max = parseFloat(this.value); //this.value;
    //chart_update();
}
IB_min.oninput = function() {

    ib_min = parseFloat(this.value);
    //chart_update();
}
X1.oninput = function() {
    calculated_curve_x[0] = parseFloat(this.value); //this.value;
    //chart_update();
}
X2.oninput = function() {
    calculated_curve_x[1] = parseFloat(this.value); //this.value;
    //chart_update();
}
X3.oninput = function() {
    calculated_curve_x[2] = parseFloat(this.value); //this.value;
  //  chart_update();
}
X4.oninput = function() {
    calculated_curve_x[3] = parseFloat(this.value); //this.value;
    //chart_update();
}
Y2.oninput = function() {
    calculated_curve_y[1] = parseFloat(this.value); //this.value;
    //chart_update();
}
Y3.oninput = function() {
    calculated_curve_y[2] = parseFloat(this.value); //this.value;
    //chart_update();
}
Y4.oninput = function() {
    calculated_curve_y[3] = parseFloat(this.value); //this.value;
    //chart_update();
}

function Zero_values(){
  var a = [];
  a.push({x:0, y:0});
  return a;
}

function chart_update() {
  if (pturbo_max < pturbo_min) {
      oe.innerHTML = "Error: Too high pturbo_min";
      oe.style.backgroundColor = "red";
  } else if(ib_min > ib_max){
      oe.innerHTML = "Error: Too high ib_min";
      oe.style.backgroundColor = "red";
  } else if(power_factor > 1){
      oe.innerHTML = "Error: Too high Cosfi";
      oe.style.backgroundColor = "red";
      power_factor = 1;
  } else if(pturbo_max > calculated_curve_y[3]){
      oe.innerHTML = "Warning: Too high pturbo_max";
      oe.style.backgroundColor = "yellow";
  } else if(pturbo_max < calculated_curve_y[3]){
      oe.innerHTML = "Warning: Too low pturbo_max";
      oe.style.backgroundColor = "yellow";
  } else if(Static_stability_limit()[0].y<ib_min){
      oe.innerHTML = "Error: Overheating curve out of range";
      oe.style.backgroundColor = "red";
  } else if(ib_max <= nominal_current){
      oe.innerHTML = "Error: Ib_max too low";
      oe.style.backgroundColor = "red";
  } else {
      oe.innerHTML = "Everything is OK";
      oe.style.backgroundColor = "green";
  }

  var checkBox = document.getElementById("Ptmax");
  if(checkBox.checked==true){
    chart.data.datasets[0].data = Pt_max();
  }else{
    chart.data.datasets[0].data = Zero_values();
  }

  var checkBox = document.getElementById("Is");
  if(checkBox.checked==true){
    chart.data.datasets[1].data = Is();
  }else{
    chart.data.datasets[1].data = Zero_values();
  }

  var checkBox = document.getElementById("Ismax");
  if(checkBox.checked==true){
    chart.data.datasets[2].data = Is_max();
  }else{
    chart.data.datasets[2].data = Zero_values();
  }

  var checkBox = document.getElementById("Ibmax");
  if(checkBox.checked==true){
    chart.data.datasets[3].data = Ib_max();
  }else{
    chart.data.datasets[3].data = Zero_values();
  }

  var checkBox = document.getElementById("Ptmin");
  if(checkBox.checked==true){
    chart.data.datasets[4].data = Pt_min();
  }else{
    chart.data.datasets[4].data = Zero_values();
  }

  var checkBox = document.getElementById("Ibmin");
  if(checkBox.checked==true){
    chart.data.datasets[5].data = Ib_min();
  }else{
    chart.data.datasets[5].data = Zero_values();
  }

  var checkBox = document.getElementById("Overheat");
  if(checkBox.checked==true){
    chart.data.datasets[6].data = Overheating();
  }else{
    chart.data.datasets[6].data = Zero_values();
  }

  var checkBox = document.getElementById("Static_st");
  if(checkBox.checked==true){
    chart.data.datasets[7].data = Static_stability_limit();
  }else{
    chart.data.datasets[7].data = Zero_values();
  }




  chart.options.scales.yAxes[0].ticks.min = -(nominal_current+1);
  chart.options.scales.yAxes[0].ticks.max = 2*(nominal_current+1);
  chart.options.scales.xAxes[0].ticks.min = -2*(nominal_current+1);
  chart.options.scales.xAxes[0].ticks.max = (nominal_current+1);

  chart.update();

  var checkBox = document.getElementById("Ptmax_rev");
  if(checkBox.checked==true){
    reschart.data.datasets[0].data = Pt_max_reversed();
  }else{
    reschart.data.datasets[0].data = Zero_values();
  }

  var checkBox = document.getElementById("Ismax_rev");
  if(checkBox.checked==true){
    reschart.data.datasets[1].data = Is_max_reversed();
  }else{
    reschart.data.datasets[1].data = Zero_values();
  }
  var checkBox = document.getElementById("Ibmax_rev");
  if(checkBox.checked==true){
    reschart.data.datasets[2].data = Ib_max_reversed();
  }else{
    reschart.data.datasets[2].data = Zero_values();
  }

  var checkBox = document.getElementById("Ibmin_rev");
  if(checkBox.checked==true){
    reschart.data.datasets[3].data = Ib_min_reversed();
  }else{
    reschart.data.datasets[3].data = Zero_values();
  }

  var checkBox = document.getElementById("Overheat0");
  if(checkBox.checked==true){
    reschart.data.datasets[4].data = overheat_reversed_0();
  }else{
    reschart.data.datasets[4].data = Zero_values();
  }

  var checkBox = document.getElementById("Overheat1");
  if(checkBox.checked==true){
    reschart.data.datasets[5].data = overheat_reversed_1();
  }else{
    reschart.data.datasets[5].data = Zero_values();
  }
  var checkBox = document.getElementById("Overheat2");
  if(checkBox.checked==true){
    reschart.data.datasets[6].data = overheat_reversed_2();
  }else{
    reschart.data.datasets[6].data = Zero_values();
  }

  var checkBox = document.getElementById("Static_st_rev");
  if(checkBox.checked==true){
    reschart.data.datasets[7].data = Static_stability_limit_rev();
  }else{
    reschart.data.datasets[7].data = Zero_values();
  }
  /*reschart.options.scales.yAxes[0].ticks.min = -(nominal_current*4)/30;
  reschart.options.scales.yAxes[0].ticks.max = (nominal_current*4)/30;
  reschart.options.scales.xAxes[0].ticks.min = -(nominal_current*4)/30;
  reschart.options.scales.xAxes[0].ticks.max = (nominal_current*4)/30;*/

  reschart.update();

}

updButton.onclick=function(){
    chart_update();
}

Button.onclick = function() {
    ib_max = 9;
    ib_min = 1;
    power_factor = 0.8; //COSfi

    pturbo_max = 3;
    pturbo_min = 1;

    nominal_current = 3; //statorovy proud

    calculated_curve_x = [-6.2, -6, -3.3, -2];
    calculated_curve_y = [0, 2.1, 2.6, 3];

    Pmax.value = pturbo_max;
    Pmin.value = pturbo_min;

    IB_max.value = ib_max;
    IB_min.value = ib_min;

    COSfi.value = power_factor;
    Current.value = nominal_current;

    X1.value = calculated_curve_x[0];
    X2.value = calculated_curve_x[1];
    X3.value = calculated_curve_x[2];
    X4.value = calculated_curve_x[3];

    Y2.value = calculated_curve_y[1];
    Y3.value = calculated_curve_y[2];
    Y4.value = calculated_curve_y[3];

    chart_update();

}





var ctx = document.getElementById('myChart').getContext('2d');
ctx.canvas.parentNode.style.height = '500px';
ctx.canvas.parentNode.style.width = '500px';

//Functions/////////////////////////////////////////////////////////


function power_angel(cosfi) {
    var alfa;
    alfa = Math.acos(cosfi);
    return alfa;
}

function sin_angle(cosfi) {
    var alfa;
    alfa = Math.sin(Math.acos(cosfi));
    return alfa;
}

function atn(x, y) {
    var ang = Math.atan(y / x);
    return ang;
}

function cos(ang) {
    return Math.cos(ang);
}

function sin(ang) {
    return Math.sin(ang);
}

/*function thetta_angel() {
    var alfa;
    var sinus = nominal_current * power_factor / ib;
    alfa = Math.asin(sinus);
    return alfa;
}*/

function rounding(num) {
    var n = num.toFixed(3);
    var double = parseFloat(n);
    return double;
}

function rounding2(num) {
    var n = num.toFixed(2);
    var double = parseFloat(n);
    return double;
}



function getting_Ib_center() {
    var center = 0;
    for (i = -ib_max + nominal_current * power_factor; i <= ib_max + nominal_current * power_factor; i += occuracy / 10) {
        if (rounding2((-Math.sqrt(Math.pow(ib_max, 2) - Math.pow(rounding2(i) - nominal_current * power_factor, 2))) + nominal_current * sin_angle(power_factor)) <= 0.05 && rounding2(-Math.sqrt(Math.pow(ib_max, 2) - Math.pow(rounding2(i) - nominal_current * power_factor, 2))) + nominal_current * sin_angle(power_factor) >= (-0.05)) {
            if (i <= 0) {
                center = rounding2(i);
            }
        }
    }
    return center;
}

var overlayer;
var overlayer_pos;

function Pt_max() {
    var center = getting_Ib_center();
    overlayer = false;
    overlayer_pos = calculated_curve_x[3];
    var max_value = nominal_current;
    var pmax = [{
        x: center - ib_min,
        y: pturbo_max
    }, {
        x: nominal_current,
        y: pturbo_max
    }];
    if (calculated_curve_y[3] < pturbo_max) {
        pmax = [{
            x: 0,
            y: 0
        }, {
            x: 0,
            y: 0
        }];
    }

    max_value = Is_max()[0].x;

    /*for(i=nominal_current;  i>=center; i-=occuracy/10){
      if(rounding2(Math.sqrt(Math.pow(nominal_current,2))-pturbo_max)<=0.05 && rounding2(Math.sqrt(Math.pow(nominal_current,2)-Math.pow(i,2))-pturbo_max)>=-0.05){
        max_value=rounding2(i);
        break;
      }
    }*/
    /*for (i = 0; i <= nominal_current; i += occuracy / 10) {
        if (rounding2((Math.sqrt(rounding2(Math.pow(nominal_current, 2)) - rounding2(Math.pow(i, 2))))) - pturbo_max <= 0.03 && rounding2((Math.sqrt(rounding2(Math.pow(nominal_current, 2)) - rounding2(Math.pow(i, 2))))) - pturbo_max >= -0.03) {
            max_value = rounding2(i);
            break;
        }
    }*/
    //if (rounding2(calculated_curve_y[3] - pturbo_max) >= -0.03 && rounding2(calculated_curve_y[3] - pturbo_max) <= 0.03) {
        /*for(i=center;i<=max_value;i+=occuracy){
          if(pturbo_max-Math.sqrt(Math.pow(ib_max,2)-Math.pow(rounding2(i)-center,2))<=0.1 && pturbo_max-Math.sqrt(Math.pow(ib_max,2)-Math.pow(rounding2(i)-center,2))>=-0.1){
            overlayer_pos=i;
            overlayer=true;
            break;
          }
        }*/
        pmax = [{
            x: calculated_curve_x[3],
            y: pturbo_max
        }, {
            x: max_value,
            y: pturbo_max
        }];
  //  }
    return pmax;
}

function Pt_min() {
    var center = getting_Ib_center();
    var pmin = [{
        x: rounding2(center - ib_min),
        y: pturbo_min
    }, {
        x: nominal_current,
        y: pturbo_min
    }];
    //for( i=(nominal_current*Math.sin(power_angel(power_factor))-ib*Math.cos(thetta_angel())); i<=nominal_current; i+=occuracy){
    //pmin.push({x:i,y:pturbo_min});
    //}
    return pmin;
}


function Is() {
    var current = [{
        x: 0,
        y: 0
    }, {
        x: rounding2(nominal_current * Math.sin(power_angel(power_factor))),
        y: rounding2(nominal_current * power_factor)
    }];
    return current;
}

function Is_max() {
    var center = getting_Ib_center();
    var current = [];
    var max_value = 0; //-nominal_current;

    if (calculated_curve_y[3] < pturbo_max) {
        max_value = calculated_curve_x[3];
    }

    for (i = max_value; i <= nominal_current; i += occuracy / 10) {
        if (rounding2((Math.sqrt(rounding2(Math.pow(nominal_current, 2)) - rounding2(Math.pow(i, 2))))) - pturbo_max <= 0.03 && rounding2((Math.sqrt(rounding2(Math.pow(nominal_current, 2)) - rounding2(Math.pow(i, 2))))) - pturbo_max >= -0.03) {
            max_value = rounding2(i);
            break;
        }
    }

    for (i = max_value; i <= nominal_current; i += occuracy / 10) {
        current.push({
            x: rounding2(i),
            y: rounding2(Math.sqrt(rounding2(Math.pow(nominal_current, 2)) - rounding2(Math.pow(i, 2))))
        });
        if (rounding2(Math.sqrt(rounding2(Math.pow(nominal_current, 2)) - rounding2(Math.pow(i, 2)))) - rounding2(Math.sqrt(rounding2(Math.pow(ib_max, 2)) - rounding2(Math.pow(rounding2(i) - center, 2)))) <= 0.05 && rounding2(Math.sqrt(rounding2(Math.pow(nominal_current, 2)) -
                rounding2(Math.pow(i, 2)))) - rounding2(Math.sqrt(rounding2(Math.pow(ib_max, 2)) - rounding2(Math.pow(rounding2(i) - center, 2)))) >= -0.05) {
            break;

        }
    }
    current.push({
        x: Ib_max()[Ib_max().length-1].x,
        y: Ib_max()[Ib_max().length-1].y
    });

    if (Ib_max()[Ib_max().length-1].y >= pturbo_max - 0.05){
      current = [{x:Ib_max()[Ib_max().length-1].x, y:0}]
    }
    return current;
}

function Ib_max() {
    var center = getting_Ib_center();
    var current = [];
    var min_value = center;

    for (i = ib_max + center; i >= min_value; i -= occuracy / 10) {
        current.push({
            x: rounding2(i),
            y: rounding2(Math.sqrt(rounding2(Math.pow(ib_max, 2)) - rounding2(Math.pow(i - center, 2))))
        });
        if ((rounding2((Math.sqrt(rounding2(Math.pow(nominal_current, 2)) - rounding2(Math.pow(i, 2)))) - rounding2(Math.sqrt(rounding2(Math.pow(ib_max, 2)) - rounding2(Math.pow(rounding2(i) - center, 2)))))) <= 0.05 && (rounding2(Math.sqrt(rounding2(Math.pow(nominal_current, 2))
        - rounding2(Math.pow(i, 2)))) - rounding2(Math.sqrt(rounding2(Math.pow(ib_max, 2)) - rounding2(Math.pow(rounding2(i) - center, 2))))) >= -0.05) {
            break;
        }
        if(rounding2(Math.sqrt(rounding2(Math.pow(ib_max, 2)) - rounding2(Math.pow(rounding2(i) - center, 2)))) - pturbo_max <= 0.05 && rounding2(Math.sqrt(rounding2(Math.pow(ib_max, 2)) - rounding2(Math.pow(rounding2(i) - center, 2)))) - pturbo_max >= -0.05){
          break;
        }
    }

    return current;
}

function Ib_min() {
    var center = getting_Ib_center();
    var current = [];
    var k = 9.9;
    var b = rounding2(0 - 9.9 * center);
    var min_value = rounding2(-ib_min + center);
    var max_value = rounding2(ib_min + center);

    //current.push({x:max_value, y:0});

    for (i = max_value; i >= min_value; i -= occuracy / 10) {
        current.push({
            x: rounding2(i),
            y: rounding2(Math.sqrt(rounding2(Math.pow(ib_min, 2)) - rounding2(Math.pow(i - center, 2))))
        });
        if (rounding2(k * i + b - Math.sqrt(Math.pow(ib_min, 2) - Math.pow(rounding2(i) - center, 2))) <= 0.03 && rounding2(k * i + b - Math.sqrt(Math.pow(ib_min, 2) - Math.pow(rounding2(i) - center, 2))) >= -0.03) {
            value = rounding2(i);
            break;
        }
    }

    //oe.innerHTML = current[0].y;
    return current;
}

function Static_stability_limit() {
    var curve = [];
    var center = getting_Ib_center();
    var k = 9.9;
    var b = 0 - 9.9 * center;
    curve.push({
        x: calculated_curve_x[0],
        y: rounding2(k * calculated_curve_x[0] + b)
    });
    for (i = 1; i <= 3; i++) {
        curve.push({
            x: calculated_curve_x[i],
            y: calculated_curve_y[i]
        });
    }
    return curve;
}

var y_value_of_heat;

function Overheating() {
    var center = getting_Ib_center();
    var k = 9.9;
    var b = rounding2(0 - 9.9 * center);
    var value;
    for (i = -ib_min + center; i <= ib_min + center; i += occuracy / 10) {
        if (rounding2(k * i + b - Math.sqrt(Math.pow(ib_min, 2) - Math.pow(rounding2(i) - center, 2))) <= 0.05 && rounding2(k * i + b - Math.sqrt(Math.pow(ib_min, 2) - Math.pow(rounding2(i) - center, 2))) >= -0.05) {
            value = rounding2(i);
            break;
        }
    }
    y_value_of_heat = rounding(k * calculated_curve_x[0] + b);
    var curve = [{
        x: calculated_curve_x[0],
        y: rounding2(k * calculated_curve_x[0] + b)
    }, {
        x: value,
        y: rounding2(k * value + b)
    }];
    return curve;
}

var chart = new Chart(ctx, {
    // The type of chart we want to create
    type: 'scatter',
    // The data for our dataset
    data: {
        datasets: [{
            label: 'Pt_max',
            borderColor: 'rgb(0, 204, 0)',
            showLine: true,
            pointRadius: 0,
            borderWidth: 4,
            fill: false,
            data: Pt_max()
        }, {
            label: 'Is',
            borderColor: 'rgb(0, 51, 102)',
            showLine: true,
            pointRadius: 0,
            borderWidth: 4,
            fill: false,
            data: Is()
        }, {
            label: 'Is_max',
            borderColor: 'rgb(51, 102, 204)',
            showLine: true,
            pointRadius: 0,
            borderWidth: 4,
            fill: false,
            data: Is_max()
        }, {
            label: 'Ib_max',
            borderColor: 'rgb(255, 51, 0)',
            showLine: true,
            pointRadius: 0,
            borderWidth: 4,
            fill: false,
            data: Ib_max()
        }, {
            label: 'Pt_min',
            borderColor: 'rgb(0, 153, 0)',
            showLine: true,
            pointRadius: 0,
            borderWidth: 4,
            fill: false,
            data: Pt_min()
        }, {
            label: 'Ib_min',
            borderColor: 'rgb(155, 51, 0)',
            showLine: true,
            pointRadius: 0,
            borderWidth: 4,
            fill: false,
            data: Ib_min()
        }, {
            label: 'Overheating',
            borderColor: 'rgb(204, 0, 102)',
            showLine: true,
            pointRadius: 0,
            borderWidth: 4,
            fill: false,
            data: Overheating()
        }, {
            label: 'Static_stability_limit',
            borderColor: 'rgb(102, 0, 51)',
            showLine: true,
            pointRadius: 0,
            borderWidth: 4,
            fill: false,
            data: Static_stability_limit()
        }]
    },



    // Configuration options go here
    options: {
        scales: {
              yAxes: [{
                  ticks: {
                      suggestedMin: -(nominal_current+1),
                      suggestedMax: (nominal_current+1)*2
                  },
                  scaleLabel: {
                      display: true,
                      labelString: "Re"
                  }
              }],
              xAxes: [{
                  ticks: {

                      min: -(nominal_current+1)*2,
                      max: (nominal_current+1)
                  },
                  scaleLabel: {
                      display: true,
                      labelString: "Im"
                    }
              }]
          }

    }
});

//Impedance graf parametrs
//Reversed Functions

function xtoy(x, y) {
    return {
        x: -y,
        y: x
    };
}

function get_k_b(x_0, x_1, y_0, y_1) {
    var x = x_0 - x_1;
    var y = y_0 - y_1;
    var k = y / x;
    var b = y_0 - x_0 * k;
    var values = [k, b];
    return values;
}

function Pt_max_reversed() {
    var pmax = [];
    var pmax_rev = [];
    var min_value = -3;
    var max_value = 5;
    var distance = max_value - min_value;

    var f;
    var ang;
    var abs;


    var n;
    n = 10;

    if(!isNaN(pturbo_max) && pturbo_max != 0){
      var i = 0;
      var start = 0;
      while(true){
        f = -pturbo_max;
        ang = -atn(i, f);
        abs = -rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
        var yo=xtoy(rounding(abs * (cos(ang))), rounding(abs * (sin(ang)))).y;
        i += occuracy/n/100;
        if (!isNaN(yo)){
          break
        }
      }
      do{
        i += occuracy/n/100;
        f = -pturbo_max;
        ang = -atn(i, f);
        abs = -rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      }while(xtoy((abs * cos(ang)), (abs * sin(ang))).y < 0);

      i -= occuracy/n;

      for(c = start; c <= i; c+=occuracy){
        f = -pturbo_max;
        ang = -atn(c, f);
        abs = -rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
        pmax.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
      }

      f = -pturbo_max;
      ang = -atn(i, f);
      abs = -rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      pmax.push(xtoy((abs * cos(ang)), (abs * sin(ang))));

      var i = 0;
      var start = -0.001;
      while(true){
        f = -pturbo_max;
        ang = -atn(i, f);
        abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
        var yo=xtoy(rounding(abs * (cos(ang))), rounding(abs * (sin(ang)))).y;
        i -= occuracy/n/100;
        if (!isNaN(yo)){
          break
        }
      }
      do{
        i -= occuracy/n/100;
        f = -pturbo_max;
        ang = -atn(i, f);
        abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      }while(xtoy((abs * cos(ang)), (abs * sin(ang))).y > 0);

      i += occuracy/n;

      for(c = i; c <= start; c+=occuracy){
        f = -pturbo_max;
        ang = -atn(c, f);
        abs = rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
        pmax.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
      }

      f = -pturbo_max;
      ang = -atn(start, f);
      abs = rounding(1 / (Math.sqrt(Math.pow(start, 2) + Math.pow(f, 2))));
      pmax.push(xtoy((abs * cos(ang)), (abs * sin(ang))));

    }

    return pmax;
}

function Ib_min_reversed() {
    var current = [];
    var center = getting_Ib_center();
    var f;
    var ang;
    var abs;
    var n;

    n = 100; // citlovost
    var r;
    if (ib_min<1){
      r=10;
    }else{
      r=1;
    }

    if(!isNaN(ib_min) && ib_min != 0){

      var i = 0;

      while(true){
        f = -(Math.sqrt((Math.pow(ib_min, 2)) - (Math.pow((i) - center, 2))));
        ang = -(atn(i, f));
        abs =  (1 / (Math.sqrt((Math.pow((i), 2)) + (Math.pow(f, 2)))));
        var yo=xtoy(rounding(abs * (cos(ang))), rounding(abs * (sin(ang)))).y;
        i -= occuracy/n/1000;
        if (!isNaN(yo)){
          break
        }
      }
      var start = i;
      do{
        i -= occuracy/n/1000;
        f = -(Math.sqrt(Math.pow(ib_min, 2) - Math.pow((i) - center, 2)));
        ang = -atn(i, f);
        abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      }while(xtoy((abs * cos(ang)), (abs * sin(ang))).x > 0);

      for(c=start; c>=i; c-=occuracy/r){
        f = -(Math.sqrt(Math.pow(ib_min, 2) - Math.pow((c) - center, 2)));
        ang = -atn(c, f);
        abs = rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
        current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
      }

      i+=occuracy/n/1000;
      f = -(Math.sqrt(Math.pow(ib_min, 2) - Math.pow((i) - center, 2)));
      ang = -atn(i, f);
      abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
      //oe.innerHTML = f


      var i = 0;

      while(true){
        f = (Math.sqrt((Math.pow(ib_min, 2)) - (Math.pow((i) - center, 2))));
        ang = -(atn(i, f));
        abs =  (1 / (Math.sqrt((Math.pow((i), 2)) + (Math.pow(f, 2)))));
        var yo=xtoy(rounding(abs * (cos(ang))), rounding(abs * (sin(ang)))).y;
        i -= occuracy/n/1000;
        if (!isNaN(yo)){
          break
        }
      }
      var start = i;
      do{
        i -= occuracy/n/1000;
        f = (Math.sqrt((Math.pow(ib_min, 2)) - (Math.pow((i) - center, 2))));
        ang = -(atn(i, f));
        abs =  (1 / (Math.sqrt((Math.pow((i), 2)) + (Math.pow(f, 2)))));

      }while(xtoy(rounding(abs * (cos(ang))), rounding(abs * (sin(ang)))).x <= 0);

      i+=occuracy/n/1000;           //one step back

      for(c=i;c<=start;c+=occuracy/r){
        f = (Math.sqrt(Math.pow(ib_min, 2) - Math.pow((c) - center, 2)));
        ang = -atn(c, f);
        abs = rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
        current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
      }

      f = (Math.sqrt(Math.pow(ib_min, 2) - Math.pow((start) - center, 2)));
      ang = -atn(start, f);
      abs = rounding(1 / (Math.sqrt(Math.pow(start, 2) + Math.pow(f, 2))));
      current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));

    }
    return current;
}

function Is_max_reversed() {
    var current = [];

    var f;
    var ang;
    var abs;
    var n;
    var r;
    if( nominal_current < 3){
        n = 300;
        r = 10;
    }else if( nominal_current < 5){
        n = 100;
        r = 5;
    }else{
        n = 10;
        r = 1;
    }

    if(!isNaN(nominal_current) && nominal_current != 0){


      var i = 0;
      var start = 0.001;
      do{
        i += occuracy/n;
        f = -(Math.sqrt(Math.pow(nominal_current, 2) - Math.pow(i, 2)))
        ang = -atn(i, f);
        abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      }while(xtoy((abs * cos(ang)), (abs * sin(ang))).x < 0.2);

      i -= occuracy/n;
      for(c = i; c>=start; c-=occuracy/r){
        f = -(Math.sqrt(Math.pow(nominal_current, 2) - Math.pow(c, 2)))
        ang = -atn(c, f);
        abs = rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
        current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
      }

      f = -(Math.sqrt(Math.pow(nominal_current, 2) - Math.pow(start, 2)))
      ang = -atn(start, f);
      abs = rounding(1 / (Math.sqrt(Math.pow(start, 2) + Math.pow(f, 2))));
      current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));

      var i = 0;
      var start = -0.01;
      do{
        i -= occuracy/n;
        f = -(Math.sqrt(Math.pow(nominal_current, 2) - Math.pow(i, 2)))
        ang = -atn(i, f);
        abs = -rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      }while(xtoy((abs * cos(ang)), (abs * sin(ang))).y < 0);

      i += occuracy/n;

      for(c = start; c>=i; c-=occuracy/r){
        f = -(Math.sqrt(Math.pow(nominal_current, 2) - Math.pow(c, 2)))
        ang = -atn(c, f);
        abs = -rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
        current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
      }
      f = -(Math.sqrt(Math.pow(nominal_current, 2) - Math.pow(i, 2)))
      ang = -atn(i, f);
      abs = -rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));

      var i = 0;
      var start =-0.001
      do{
        i -= occuracy/n;
        f = (Math.sqrt(Math.pow(nominal_current, 2) - Math.pow(i, 2)))
        ang = -atn(i, f);
        abs = -rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      }while(xtoy((abs * cos(ang)), (abs * sin(ang))).x > 0);

      i += occuracy/n;

      for(c = i; c<=start; c+=occuracy/r){
        f = (Math.sqrt(Math.pow(nominal_current, 2) - Math.pow(c, 2)))
        ang = -atn(c, f);
        abs = -rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
        current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
      }
      f = (Math.sqrt(Math.pow(nominal_current, 2) - Math.pow(start, 2)))
      ang = -atn(start, f);
      abs = -rounding(1 / (Math.sqrt(Math.pow(start, 2) + Math.pow(f, 2))));
      current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));

      var i = 0;
      var start = 0;
      do{
        i += occuracy/n;
        f = (Math.sqrt(Math.pow(nominal_current, 2) - Math.pow(i, 2)))
        ang = -atn(i, f);
        abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      }while(xtoy((abs * cos(ang)), (abs * sin(ang))).y > 0);

      i -= occuracy/n;

      for(c = start; c<=i; c+=occuracy/r){
        f = (Math.sqrt(Math.pow(nominal_current, 2) - Math.pow(c, 2)))
        ang = -atn(c, f);
        abs = rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
        current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
      }
      f = (Math.sqrt(Math.pow(nominal_current, 2) - Math.pow(i, 2)))
      ang = -atn(i, f);
      abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));


  }

    return current;
}


function Ib_max_reversed() {
    var current = [];
    var center = getting_Ib_center();
    var f;
    var ang;
    var abs;
    var n;
    var r;
    if(ib_max < 1.2 || nominal_current < 1.2){
        n = 1000;
        r = 10;
    }else if(ib_max < 5 || nominal_current < 5){
        n = 100;
        r = 10;
    }else{
        n = 10;
        r = 1;
    }



    if(!isNaN(ib_max) && ib_max != 0){
      var i = 0;
      var start = 0;
      do{
        i += occuracy/n/1000;
        f = -(Math.sqrt(Math.pow(ib_max, 2) - Math.pow((i) - center, 2)));
        ang = -atn(i, f);
        abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      }while(xtoy((abs * cos(ang)), (abs * sin(ang))).x < 0);

      for(c=start;c<=i;c+=occuracy/r){
        f = -(Math.sqrt(Math.pow(ib_max, 2) - Math.pow((c) - center, 2)));
        ang = -atn(c, f);
        abs = rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
        current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
      }

      i-=occuracy/n/1000;
      f = -(Math.sqrt(Math.pow(ib_max, 2) - Math.pow((i) - center, 2)));
      ang = -atn(i, f);
      abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
      //oe.innerHTML = f


      var i = 0;
      var start = 0;
      do{
        i += occuracy/n/1000;
        f = (Math.sqrt(Math.pow(ib_max, 2) - Math.pow((i) - center, 2)));
        ang = -atn(i, f);
        abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      }while(xtoy((abs * cos(ang)), (abs * sin(ang))).x > -0.2);

      i-=occuracy/n/1000;           //one step back

      for(c=i;c>=start;c-=occuracy/r){
        f = (Math.sqrt(Math.pow(ib_max, 2) - Math.pow((c) - center, 2)));
        ang = -atn(c, f);
        abs = rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
        current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
      }

      f = (Math.sqrt(Math.pow(ib_max, 2) - Math.pow((start) - center, 2)));
      ang = -atn(start, f);
      abs = rounding(1 / (Math.sqrt(Math.pow(start, 2) + Math.pow(f, 2))));
      current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));



      var i = 0;
      var start = -0.001;
      do{
        i -= occuracy/n/1000;
        f = (Math.sqrt(Math.pow(ib_max, 2) - Math.pow((i) - center, 2)));
        ang = -atn(i, f);
        abs = -rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      }while(xtoy((abs * cos(ang)), (abs * sin(ang))).y < 0);

      i+=occuracy/n/1000;           //one step back

      for(c=start;c>=i;c-=occuracy/r){
        f = (Math.sqrt(Math.pow(ib_max, 2) - Math.pow((c) - center, 2)));
        ang = -atn(c, f);
        abs = -rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
        current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
      }

      f = (Math.sqrt(Math.pow(ib_max, 2) - Math.pow((i) - center, 2)));
      ang = -atn(i, f);
      abs = -rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));


      var i = 0;
      var start = -0.001;
      do{
        i -= occuracy/n/1000;
        f = -(Math.sqrt(Math.pow(ib_max, 2) - Math.pow((i) - center, 2)));
        ang = -atn(i, f);
        abs = -rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      }while(xtoy((abs * cos(ang)), (abs * sin(ang))).y < 0);

      i+=occuracy/n/1000;           //one step back

      for(c=i;c<=start;c+=occuracy/r){
        f = -(Math.sqrt(Math.pow(ib_max, 2) - Math.pow((c) - center, 2)));
        ang = -atn(c, f);
        abs = -rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
        current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
      }

      f = -(Math.sqrt(Math.pow(ib_max, 2) - Math.pow((start) - center, 2)));
      ang = -atn(start, f);
      abs = -rounding(1 / (Math.sqrt(Math.pow(start, 2) + Math.pow(f, 2))));
      current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));

/*
      var i = -0.01;
      do{
        f = (Math.sqrt(Math.pow(ib_max, 2) - Math.pow((i) - center, 2)));
        ang = -atn(i, f);
        abs = -rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
        current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
        i -= occuracy/n;
      }while(xtoy((abs * cos(ang)), (abs * sin(ang))).y < 0.2);

      var i = -0.01;
      do{
        f = -(Math.sqrt(Math.pow(ib_max, 2) - Math.pow((i) - center, 2)));
        ang = -atn(i, f);
        abs = -rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
        current.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
        i -= occuracy/n;
        //oe.innerHTML = xtoy((abs * cos(ang)), (abs * sin(ang))).x;
      }while(xtoy((abs * cos(ang)), (abs * sin(ang))).y < 0.2);
      */
  }

    return current;
}

/*function down_bound() {
    var bound = [];
    //var center = getting_Ib_center();

    var f;
    var ang;
    var abs;
    //var max_value = nominal_current;
    //var min_value = center+ib_min;
    for (i = -nominal_current * 10; i <= nominal_current * 10; i += occuracy / 10) {
        f = 0.001;
        ang = -atn(i, f);
        abs = -rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
        bound.push(xtoy(rounding(abs * cos(ang)), rounding(abs * sin(ang))));
    }

    return bound;
}*/
//1. curve
function overheat_reversed_0() {
    var curve = [];
    var curve_rev = [];
    var center = getting_Ib_center();
    var y_0 = y_value_of_heat;
    var k = rounding(get_k_b(calculated_curve_x[0], calculated_curve_x[1], y_0, calculated_curve_y[1])[0]);
    var b = rounding(get_k_b(calculated_curve_x[0], calculated_curve_x[1], y_0, calculated_curve_y[1])[1]);

    var f;
    var ang;
    var abs;


    var n = 10;

    var i = 0;



    var start = 0;

    do{
      i += occuracy/n;
      f = k * i + b;
      ang = -atn(i, f);
      abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));

    }while(xtoy((abs * cos(ang)), (abs * sin(ang))).y > 0);
    i -= occuracy/n;
    for(c=start;c<=i;c+=occuracy){
      f = k * c + b;
      ang = -atn(c, f);
      abs = rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
      curve.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
    }
    f = k * i + b;
    ang = -atn(i, f);
    abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
    curve.push(xtoy((abs * cos(ang)), (abs * sin(ang))));

    var i = 0;




    var start = -0.001;

    do{
      i -= occuracy/n;
      f = (k * i + b);
      ang = -atn(i, f);
      abs = rounding(-1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));

    }while(xtoy((abs * cos(ang)), (abs * sin(ang))).y < 0);
    i += occuracy/n;
    for(c=i;c<=start;c+=occuracy){
      f = k * c + b;
      ang = -atn(c, f);
      abs = -rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
      curve.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
    }
    f = k * start + b;
    ang = -atn(start, f);
    abs = -rounding(1 / (Math.sqrt(Math.pow(start, 2) + Math.pow(f, 2))));
    curve.push(xtoy((abs * cos(ang)), (abs * sin(ang))));

    return curve;
}
//2. curve
function overheat_reversed_1() {
    var curve = [];
    var curve_rev = [];
    var center = getting_Ib_center();
    var k = rounding(get_k_b(calculated_curve_x[1], calculated_curve_x[2], calculated_curve_y[1], calculated_curve_y[2])[0]);
    var b = rounding(get_k_b(calculated_curve_x[1], calculated_curve_x[2], calculated_curve_y[1], calculated_curve_y[2])[1]);

    var f;
    var ang;
    var abs;

    var n = 10;

    var i = 0;

    /*while(true){
      f = k * i + b;
      ang = -atn(i, f);
      abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      var yo=xtoy((abs * (cos(ang))), (abs * (sin(ang)))).y;
      i += occuracy/n/1000;
      if (!isNaN(yo)){
        break
      }
    }
*/
    var start=i;

    do{
      i += occuracy/n;
      f = k * i + b;
      ang = -atn(i, f);
      abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));

    }while(xtoy((abs * cos(ang)), (abs * sin(ang))).y > 0);
    i -= occuracy/n;
    for(c=start;c<=i;c+=occuracy){
      f = k * c + b;
      ang = -atn(c, f);
      abs = rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
      curve.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
    }

    f = k * i + b;
    ang = -atn(i, f);
    abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
    curve.push(xtoy((abs * cos(ang)), (abs * sin(ang))));

    var i = 0;
  /*  while(true){
      f = (k * i + b);
      ang = -atn(i, f);
      abs = rounding(-1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      var yo=xtoy((abs * (cos(ang))), (abs * (sin(ang)))).y;
      i -= occuracy/n/1000;
      if (!isNaN(yo)){
        break
      }
    }*/

    var start=-0.001;

    do{
      i -= occuracy/n;
      f = (k * i + b);
      ang = -atn(i, f);
      abs = rounding(-1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));

    }while(xtoy((abs * cos(ang)), (abs * sin(ang))).y < 0);
    i += occuracy/n;
    for(c=i;c<=start;c+=occuracy){
      f = k * c + b;
      ang = -atn(c, f);
      abs = -rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
      curve.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
    }

    f = k * start + b;
    ang = -atn(start, f);
    abs = -rounding(1 / (Math.sqrt(Math.pow(start, 2) + Math.pow(f, 2))));
    curve.push(xtoy((abs * cos(ang)), (abs * sin(ang))));


    return curve;
}


//3. curve
function overheat_reversed_2() {
    var curve = [];
    var curve_rev = [];
    var center = getting_Ib_center();

    //var distance = Math.sqrt(Math.pow(calculated_curve_x[3]-calculated_curve_x[2],2)+Math.pow(calculated_curve_y[3]-calculated_curve_y[2],2));
    var k = rounding(get_k_b(calculated_curve_x[2], calculated_curve_x[3], calculated_curve_y[2], calculated_curve_y[3])[0]);
    var b = rounding(get_k_b(calculated_curve_x[2], calculated_curve_x[3], calculated_curve_y[2], calculated_curve_y[3])[1]);

    var f;
    var ang;
    var abs;


    var n = 10;

    var i = 0;
    /*while(true){
      f = k * i + b;
      ang = -atn(i, f);
      abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      var yo=xtoy((abs * (cos(ang))), (abs * (sin(ang)))).y;
      i += occuracy/n/1000;
      if (!isNaN(yo)){
        break
      }
    }
*/
    var start=i;

    do{
      i += occuracy/n;
      f = k * i + b;
      ang = -atn(i, f);
      abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));

    }while(xtoy((abs * cos(ang)), (abs * sin(ang))).y > 0);
    i -= occuracy/n;
    for(c=start;c<=i;c+=occuracy){
      f = k * c + b;
      ang = -atn(c, f);
      abs = rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
      curve.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
    }
    f = k * i + b;
    ang = -atn(i, f);
    abs = rounding(1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
    curve.push(xtoy((abs * cos(ang)), (abs * sin(ang))));

    var i = 0;
  /*  while(true){
      f = (k * i + b);
      ang = -atn(i, f);
      abs = rounding(-1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));
      var yo=xtoy((abs * (cos(ang))), (abs * (sin(ang)))).y;
      i -= occuracy/n/1000;
      if (!isNaN(yo)){
        break
      }
    }*/

    var start=-0.001;

    do{
      i -= occuracy/n;
      f = (k * i + b);
      ang = -atn(i, f);
      abs = rounding(-1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2))));

    }while(xtoy((abs * cos(ang)), (abs * sin(ang))).y < 0);
    i += occuracy/n/1000;
    for(c=i;c<=start;c+=occuracy){
      f = k * c + b;
      ang = -atn(c, f);
      abs = -rounding(1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2))));
      curve.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
    }

    f = k * start + b;
    ang = -atn(start, f);
    abs = -rounding(1 / (Math.sqrt(Math.pow(start, 2) + Math.pow(f, 2))));
    curve.push(xtoy((abs * cos(ang)), (abs * sin(ang))));

    return curve;
}

function Static_stability_limit_rev() {
    var center = getting_Ib_center();
    var k = 99;
    var b = 0 - k * center;
    var min_value = -1;
    var max_value = 3;
    var curve = [];

    var f;
    var ang;
    var abs;

    var n = 10;

    var i = 0;

    while(true){
      f = k * i + b;
      ang = -atn(i, f);
      abs = -1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2)));
      var yo=xtoy((abs * (cos(ang))), (abs * (sin(ang)))).y;
      i -= occuracy/n/1000;
      if (!isNaN(yo)){
        break
      }
    }

    var start=i;

    do{
      i -= occuracy/n/1000;
      f = (k * i + b);
      ang = -atn(i, f);
      abs = -1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2)));
    }while(xtoy((abs * cos(ang)), (abs * sin(ang))).x > 0);

    i += occuracy/n/1000;

    for(c=i; c<=start; c+=occuracy/n){                                //check twice
      f = (k * c + b);
      ang = -atn(c, f);
      abs = -1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2)));
      curve.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
    }

    f = k * (start) + b;
    ang = -atn(start, f);
    abs = -1 / (Math.sqrt(Math.pow(start, 2) + Math.pow(f, 2)));
    curve.push(xtoy((abs * cos(ang)), (abs * sin(ang))));


    var i = 0;

    while(true){
      f = -(k * i + b);
      ang = -atn(i, f);
      abs = -1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2)));
      var yo=xtoy((abs * (cos(ang))), (abs * (sin(ang)))).y;
      i -= occuracy/n/1000;
      if (!isNaN(yo)){
        break
      }
    }

    var start=i;

    do{
      i -= occuracy/n/1000;
      f = -(k * i + b);
      ang = -atn(i, f);
      abs = -1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2)));
    }while(xtoy((abs * cos(ang)), (abs * sin(ang))).x < 0);

    i += occuracy/n/1000;

    for(c=start; c>=i; c-=occuracy/n){                    //double check
      f = -(k * c + b);
      ang = -atn(c, f);
      abs = -1 / (Math.sqrt(Math.pow(c, 2) + Math.pow(f, 2)));
      curve.push(xtoy((abs * cos(ang)), (abs * sin(ang))));
    }

    f = -(k * (i) + b);
    ang = -atn(i, f);
    abs = -1 / (Math.sqrt(Math.pow(i, 2) + Math.pow(f, 2)));
    curve.push(xtoy((abs * cos(ang)), (abs * sin(ang))));

    return curve;
}

var result = document.getElementById('theResult').getContext('2d');
result.canvas.parentNode.style.height = '500px';
result.canvas.parentNode.style.width = '500px';
//Impedance graf
var reschart = new Chart(result, {
    // The type of chart we want to create
    type: 'scatter',

    // The data for our dataset
    data: {
        datasets: [{
                label: 'Pt_max_reversed',
                borderColor: 'rgb(0, 204, 0)',
                showLine: true,
                pointRadius: 0,
                borderWidth: 3,
                fill: false,
                data: Pt_max_reversed()
            }, {
                label: 'Is_max_reversed',
                borderColor: 'rgb(51, 102, 204)',
                showLine: true,
                pointRadius: 0,
                borderWidth: 3,
                fill: false,
                data: Is_max_reversed()
            },{
                label: 'Ib_max_reversed',
                borderColor: 'rgb(255, 51, 0)',
                showLine: true,
                pointRadius: 0,
                borderWidth: 3,
                fill: false,
                data: Ib_max_reversed()
            }, {
                label: 'Ib_min_reversed',
                borderColor: 'rgb(155, 51, 0)',
                showLine: true,
                pointRadius: 0,
                borderWidth: 3,
                fill: false,
                data: Ib_min_reversed()
            }, {
                label: 'Overheating_rev_0',
                borderColor: 'rgb(176, 0, 98)',
                showLine: true,
                pointRadius: 0,
                borderWidth: 3,
                fill: false,
                data: overheat_reversed_0()
            }, {
                label: 'Overheating_rev_1',
                borderColor: 'rgb(200, 0, 100)',
                showLine: true,
                pointRadius: 0,
                borderWidth: 3,
                fill: false,
                data: overheat_reversed_1()
            }, {
                label: 'Overheating_rev_2',
                borderColor: 'rgb(234, 0, 102)',
                showLine: true,
                pointRadius: 0,
                borderWidth: 3,
                fill: false,
                data: overheat_reversed_2()
            }, {
                label: 'Static_stability_limit',
                borderColor: 'rgb(102, 0, 51)',
                showLine: true,
                pointRadius: 0,
                borderWidth: 3,
                fill: false,
                data: Static_stability_limit_rev()
            }
        ]
    },

    // Configuration options go here
    options: {

        scales: {
              yAxes: [{

                  scaleLabel: {
                      display: true,
                      labelString: "Im"
                  }
              }],
              xAxes: [{

                  scaleLabel: {
                      display: true,
                      labelString: "Re"
                  }
              }]
          }
    }
});
